#include "testlib.h"

using namespace std;

const int MAX_A = 1000000000;

using ll = long long;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    int max_a = has_opt("a") ? opt<int>("a") : MAX_A;
    int aw = has_opt("w") ? opt<int>("w") : 5;

    bool all_eq = has_opt("all-eq") && opt<int>("all-eq");
    bool min_one = has_opt("min-one") && opt<int>("min-one");

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        if (i > 0 && all_eq) {
            a[i] = a[i - 1];
            continue;
        }
        a[i] = 1 + rnd.wnext(max_a, aw);
    }

    if (min_one) {
        a[0] = 1;
        if (rnd.next(10) == 0) {
            a[rnd.next(n)] = 1;
        }
    }

    println(n);
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%d", a[i]);
    }
    printf("\n");
}
