#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 500'000;
    int const A = 1000'000'000;

    // @formatter:off
    vector<int> const Ng{N, 500, 2000, N, N, N,       N, N};
    vector<int> const Ag{A, 200,  500, 4, A, A, 200'000, A};
    // @formatter:on

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int n = inf.readInt(2, Ng[__g], "n");
    inf.readEoln();
    auto a = inf.readInts(n, 1, Ag[__g], "a");
    inf.readEoln();
    inf.readEof();

    if (__g == 4) {
        for (int i = 1; i < n; ++i) {
            ensuref(a[0] == a[i], "group 4: all a_i should be equal, but a[%d] != a[1]", i + 1);
        }
    } else if (__g == 5) {
        ensuref(a[0] == 1, "group 5: a_1 should be equal 1");
    }
}