#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
 
void mcin() {}
 
template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);
 
template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}
 
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}
 
template<typename T1, typename T2>
struct phash {
    size_t operator()(pair<T1, T2> const &p) const {
        return (hash<T1>()(p.first) * 177013u) ^ hash<T2>()(p.second);
    }
};
 
#define all(c) c.begin(), c.end()
 
inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}
 
inline int mod3(int x) {
    int d = x % 3;
    return d < 0 ? d + 3 : d;
}

int n, cost;
double gamma;
vector<pii> xy;

vector<pii> greedy() {
    unordered_set<pii, phash<int, int>> cells(all(xy));
    map<pair<pii, bool>, int> l_id;
    map<pii, int> r_id;
    vector<unordered_set<int>> l, r;
    vector<pii> remap_r;
    auto get_l_id = [&](pii const &p, bool dir) {
        auto id = make_pair(p, dir);
        if (!l_id.count(id)) {
            int sz = l_id.size();
            l_id[id] = sz;
            l.emplace_back();
        }
        return l_id[id];
    };
    auto get_r_id = [&](pii const &p) {
        if (!r_id.count(p)) {
            int sz = r_id.size();
            r_id[p] = sz;
            remap_r.push_back(p);
            r.emplace_back();
        }
        return r_id[p];
    };
    auto add_edge = [&](int left, int right) {
        l[left].insert(right);
        r[right].insert(left);
    };
 
    for (auto const &p: xy) {
        auto x1 = around(p, 0), x2 = around(p, 1);
        auto y1 = around(p, 3), y2 = around(p, 4);
        if (cells.count(x1) && cells.count(x2)) {
            int left = get_l_id(p, false);
            int a = get_r_id(p), b = get_r_id(x1), c = get_r_id(x2);
            add_edge(left, a);
            add_edge(left, b);
            add_edge(left, c);
        }
        if (cells.count(y1) && cells.count(y2)) {
            int left = get_l_id(p, true);
            int a = get_r_id(p), b = get_r_id(y1), c = get_r_id(y2);
            add_edge(left, a);
            add_edge(left, b);
            add_edge(left, c);
        }
    }
 
    auto cmp = [&](int x, int y) {
        return r[x].size() > r[y].size() || r[x].size() == r[y].size() && x < y;
    };
    vector<set<int, decltype(cmp)>> vr(3, set<int, decltype(cmp)>(cmp));
    auto decrease = [&](int right, int left) {
        auto const &p = remap_r[right];
        int i = mod3(p.second - p.first);
        vr[i].erase(right);
        r[right].erase(left);
        vr[i].insert(right);
    };
 
    for (int i = 0; i < r.size(); i++) {
        auto const &p = remap_r[i];
        vr[mod3(p.second - p.first)].insert(i);
    }
    vector<bool> marked(l.size(), false);
    int cnt = 0;
 
    vector<pii> ans;
    while (cnt < l.size()) {
        vector<pii> opts;
        for (int i = 0; i < 3; i++)
            opts.push_back({vr[i].empty() ? 0 : r[*vr[i].begin()].size(), i});
        sort(all(opts));
        int opt = opts[2].second;
 
        int x = *vr[opt].begin();
        vr[opt].erase(vr[opt].begin());
        ans.push_back(remap_r[x]);
 
        for (int left: r[x]) {
            if (!marked[left]) cnt++;
            marked[left] = true;
            for (int right: l[left])
                if (right != x)
                    decrease(right, left);
        }
    }
 
    return ans;
}

vector<vector<int>> g, ch;
vector<int> up, tin, vis;
int t = 0;

int dfs(int v, int p) {
    vis[v] = true;
    up[v] = tin[v] = t++;
    for (int u : g[v]) {
        if (u == p) continue;
        if (vis[u]) up[v] = min(up[v], tin[u]);
        else {
            up[v] = min(up[v], dfs(u, v));
            ch[v].push_back(u);
        }
    }

    return up[v];
}

vector<int> vis2;

void dfs2(int v, vector<vector<int>> &ans) {
    vis2[v] = true;
    auto cell = xy[v];
    int color = mod3(cell.second - cell.first);
    ans[color].push_back(v);

    for (int u : ch[v]) {
        if (up[u] > tin[v]) continue;
        dfs2(u, ans);
    }
}

vector<pii> colors() {
    map<pii, int> cells;
    for (int i = 0; i < n; i++) {
        cells[xy[i]] = i;
    }

    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 6; j++) {
            auto nei = around(xy[i], j);
            if (cells.count(nei)) {
                g[i].push_back(cells[nei]);
            }
        }
    }
    up.resize(n);
    tin.resize(n);
    vis.resize(n);
    ch.resize(n);
    for (int i = 0; i < n; i++) {
        if (!vis[i]) dfs(i, -1);
    }

    set<pii> ans;
    vis2.resize(n);
    for (int i = 0; i < n; i++) {
        if (!vis2[i]) {
            vector<vector<int>> res(3);
            dfs2(i, res);
            if (res[0].size() > res[1].size()) swap(res[0], res[1]);
            if (res[0].size() > res[2].size()) swap(res[0], res[2]);
            for (int v : res[0]) ans.insert(xy[v]);
        }
    }

    vector<pii> ans_v(all(ans));
    return ans_v;
}

int main() {
 
    cin >> n >> cost >> gamma;
    xy.resize(n);
    cin >> xy;
    
    auto c = colors(), gr = greedy();
    if (c.size() < gr.size()) {
        swap(c, gr);
    }
    cout << gr.size() << '\n';
    for (auto const &p : gr) {
        cout << p.first << ' ' << p.second << '\n';
    }
    
}
    
