#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

template<typename T1, typename T2>
struct phash {
    size_t operator()(pair<T1, T2> const &p) const {
        return (hash<T1>()(p.first) * 177013u) ^ hash<T2>()(p.second);
    }
};

#define all(c) c.begin(), c.end()

inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}

inline int mod3(int x) {
    int d = x % 3;
    return d < 0 ? d + 3 : d;
}

int main() {

    in(int, n, cost)
    in(double, gamma)
    vector<pii> xy(n);
    cin >> xy;
    unordered_set<pii, phash<int, int>> cells(all(xy));

    map<pair<pii, bool>, int> l_id;
    map<pii, int> r_id;
    vector<unordered_set<int>> l, r;
    vector<pii> remap_r;
    auto get_l_id = [&](pii const &p, bool dir) {
        auto id = make_pair(p, dir);
        if (!l_id.count(id)) {
            int sz = l_id.size();
            l_id[id] = sz;
            l.emplace_back();
        }
        return l_id[id];
    };
    auto get_r_id = [&](pii const &p) {
        if (!r_id.count(p)) {
            int sz = r_id.size();
            r_id[p] = sz;
            remap_r.push_back(p);
            r.emplace_back();
        }
        return r_id[p];
    };
    auto add_edge = [&](int left, int right) {
        l[left].insert(right);
        r[right].insert(left);
    };

    for (auto const &p: xy) {
        auto x1 = around(p, 0), x2 = around(p, 1);
        auto y1 = around(p, 3), y2 = around(p, 4);
        if (cells.count(x1) && cells.count(x2)) {
            int left = get_l_id(p, false);
            int a = get_r_id(p), b = get_r_id(x1), c = get_r_id(x2);
            add_edge(left, a);
            add_edge(left, b);
            add_edge(left, c);
        }
        if (cells.count(y1) && cells.count(y2)) {
            int left = get_l_id(p, true);
            int a = get_r_id(p), b = get_r_id(y1), c = get_r_id(y2);
            add_edge(left, a);
            add_edge(left, b);
            add_edge(left, c);
        }
    }

    auto cmp = [&](int x, int y) {
        return r[x].size() > r[y].size() || r[x].size() == r[y].size() && x < y;
    };
    vector<set<int, decltype(cmp)>> vr(3, set<int, decltype(cmp)>(cmp));
    auto decrease = [&](int right, int left) {
        auto const &p = remap_r[right];
        int i = mod3(p.second - p.first);
        vr[i].erase(right);
        r[right].erase(left);
        vr[i].insert(right);
    };

    for (int i = 0; i < r.size(); i++) {
        auto const &p = remap_r[i];
        vr[mod3(p.second - p.first)].insert(i);
    }
    vector<bool> marked(l.size(), false);
    int cnt = 0;

    vector<pii> ans;
    while (cnt < l.size()) {
        vector<pii> opts;
        for (int i = 0; i < 3; i++)
            opts.push_back({vr[i].empty() ? 0 : r[*vr[i].begin()].size(), i});
        sort(all(opts));
        int opt = opts[2].second;

        int x = *vr[opt].begin();
        vr[opt].erase(vr[opt].begin());
        ans.push_back(remap_r[x]);

        for (int left: r[x]) {
            if (!marked[left]) cnt++;
            marked[left] = true;
            for (int right: l[left])
                if (right != x)
                    decrease(right, left);
        }
    }

    cout << ans.size() << '\n';
    for (auto const &p: ans)
        cout << p.first << ' ' << p.second << '\n';

}