#include "testlib.h"
#include <sstream>
#include <vector>
#include <iostream>

using namespace std;

int readAns(InStream &in, int m, string s, string t) {
    int n = (int) s.size();
    int k = in.readInt(-1, m);
    if (k == -1) return -1;
    for (int i = 0; i < k; i++) {
        int pos = in.readInt(0, n);
        reverse(s.begin(), s.begin() + (n - pos));
        reverse(s.begin(), s.end());
    }
    if (s != t) {
        in.quitf(_wa, "S is not equal after all operations: S = %s, T = %s", s.c_str(), t.c_str());
    }
    return k;
}

int main(int argc, char ** argv) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    string s = inf.readToken();
    string t = inf.readToken();
    int ja = readAns(ans, m, s, t);
    int pa = readAns(ouf, m, s, t);
    if ((ja >= 0) == (pa >= 0)) {
        if (ja == -1) {
            quitf(_ok, "[n = %d, m = %d], OK: No solution", n, m);
        } else {
            quitf(_ok, "[n = %d, m = %d], OK, %d operations", n, m, pa);
        }
    } else {
        if (ja == -1) {
            quitf(_fail, "[n = %d, m = %d] Participant found correct solution", n, m);
        } else {
            quitf(_wa, "[n = %d, m = %d] No solution found, but it exists", n, m);
        }
    }
}
